//---------------------------------------------------------------------------

#ifndef FlechesH
#define FlechesH
//---------------------------------------------------------------------------
#include <SysUtils.hpp>
#include <Controls.hpp>
#include <Classes.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>

//---------------------------------------------------------------------------
enum TFPositionLigne {Verticale ,Horizontale ,DiagonaleDroite,DiagonaleGauche,
                        CoudeDroiteHaut,CoudeGaucheHaut,CoudeDroiteBas,
                                CoudeGaucheBas,CompleteDroite,CompleteDiagonale};
enum TFPositionPointe {Doubles, Gauche, Droite, Sans};
enum TFFormePointe {Classic,Ronde,Carre,Losange}; //,Trait
enum TFTypePointe {Pleine,Vide};
//---------------------------------------------------------------------------

class TPointContact
{
private:
        int FX;
        int FY;

public:
       __property int X  = { read=FX, write=FX };
       __property int Y  = { read=FY, write=FY };
};

//----------------------------------------------------------------------
//***********Les Flches********************
//----------------------------------------------------------------------
class PACKAGE TFleches : public TGraphicControl
{

private:
        //**** La Ligne
        TFPositionLigne FPositionLigne;
        TPen* FStyleLigne;
        TBrush* FStyleFondLigne;
        void __fastcall SetPositionLigne(TFPositionLigne value);
        void __fastcall SetOnCreate(TNotifyEvent value);
        void __fastcall SetStyleLigne(TPen* value);
        void __fastcall SetStyleFondLigne(TBrush* value);

        //*******pointe 1
        TFTypePointe FPointe1Type;
        int FPointe1Longueur;
        int FPointe1Largeur;
        TColor FPointe1Couleur;
        TFFormePointe FPointe1Forme;
        void __fastcall SetPointe1Forme(TFFormePointe value);
        void __fastcall SetPointe1Longueur(int value);
        void __fastcall SetPointe1Largeur(int value);
        void __fastcall SetPointe1Couleur(TColor value);
        void __fastcall SetPointe1Type(TFTypePointe value);
        //*******pointe 2
        TFTypePointe FPointe2Type;
        int FPointe2Longueur;
        int FPointe2Largeur;
        TColor FPointe2Couleur;
        TFFormePointe FPointe2Forme;
        void __fastcall SetPointe2Forme(TFFormePointe value);
        void __fastcall SetPointe2Longueur(int value);
        void __fastcall SetPointe2Largeur(int value);
        void __fastcall SetPointe2Couleur(TColor value);
        void __fastcall SetPointe2Type(TFTypePointe value);

        TFPositionPointe FPositionPointe;
        void __fastcall SetPositionPointe(TFPositionPointe value);
        TNotifyEvent FOnCreate;
	Windows::TPoint* LaPointe;
	Windows::TPoint* LaPointe2;
        TPointContact FPointContactHaut;
        TPointContact FPointCentral;
        TPointContact FPointContactGauche;
        TPointContact FPointContactBas;
        TPointContact FPointContactDroite;
        TPointContact FPointContactDGH;
        TPointContact FPointContactDGB;
        TPointContact FPointContactDDH;
        TPointContact FPointContactDDB;
        float FAngleLigne;
        float FAnglePointe;
        int FPointe1Epaisseur;
        int FPointe2Epaisseur;
	virtual Windows::TPoint* __fastcall CreePointe(int APosLigne, int Place);
	virtual Windows::TPoint* __fastcall CreeLosange(int APosLigne, int Place);
        void __fastcall SetPointe1Epaisseur(int value);
        void __fastcall SetPointe2Epaisseur(int value);
        __property TPointContact PointContactHaut  = { read=FPointContactHaut, write=FPointContactHaut };
        __property TPointContact PointCentral  = { read=FPointCentral, write=FPointCentral };
        __property TPointContact PointContactGauche  = { read=FPointContactGauche, write=FPointContactGauche };
        __property TPointContact PointContactBas  = { read=FPointContactBas, write=FPointContactBas };
        __property TPointContact PointContactDroite  = { read=FPointContactDroite, write=FPointContactDroite };
        __property TPointContact PointContactDGH  = { read=FPointContactDGH, write=FPointContactDGH };
        __property TPointContact PointContactDGB  = { read=FPointContactDGB, write=FPointContactDGB };
        __property TPointContact PointContactDDH  = { read=FPointContactDDH, write=FPointContactDDH };
        __property TPointContact PointContactDDB  = { read=FPointContactDDB, write=FPointContactDDB };
        __property float AngleLigne  = { read=FAngleLigne, write=FAngleLigne };
        __property float AnglePointe  = { read=FAnglePointe, write=FAnglePointe };

protected:
        virtual void __fastcall Paint();
public:
        __fastcall TFleches(TComponent* Owner);
        virtual void __fastcall InitialiseFleche();
        virtual void __fastcall ConstruitLigne();
	virtual void __fastcall DessineLigne();
        virtual void __fastcall DefineDiag(int PosPointe);
        virtual void __fastcall ConstruitPointe();
        virtual void __fastcall DessinePointe1(int APosLigne ,int Place);
        virtual void __fastcall DessinePointe2(int APosLigne);
        __fastcall ~TFleches();
        void __fastcall StyleChange(TObject* Owner);
        virtual void __fastcall SiCreate(TObject *Sender);
        
__published:
        __property DragCursor ;
        __property DragMode ;
        __property OnDragDrop ;
        __property OnDragOver ;
        __property OnEndDrag ;
        __property OnMouseDown ;
        __property OnMouseMove ;
        __property OnMouseUp ;
        __property OnResize ;
        __property OnClick ;
        __property TNotifyEvent OnCreate  = { read=FOnCreate, write=SetOnCreate };
        //--------Ligne-------
        __property TPen* StyleLigne  = { read=FStyleLigne, write=SetStyleLigne };
        __property TBrush* StyleFondLigne  = { read=FStyleFondLigne, write=SetStyleFondLigne };
        __property TFPositionLigne PositionLigne  = { read=FPositionLigne, write=SetPositionLigne };
        //--------Pointe1
        __property TFTypePointe Pointe1Type  = { read=FPointe1Type, write=SetPointe1Type };
        __property int Pointe1Longueur  = { read=FPointe1Longueur, write=SetPointe1Longueur };
        __property int Pointe1Largeur  = { read=FPointe1Largeur, write=SetPointe1Largeur };
        __property TColor Pointe1Couleur  = { read=FPointe1Couleur, write=SetPointe1Couleur };
        __property TFFormePointe Pointe1Forme  = { read=FPointe1Forme, write=SetPointe1Forme };
        __property int Pointe1Epaisseur  = { read=FPointe1Epaisseur, write=SetPointe1Epaisseur };
        //--------Pointe2
        __property TFTypePointe Pointe2Type  = { read=FPointe2Type, write=SetPointe2Type };
        __property int Pointe2Longueur  = { read=FPointe2Longueur, write=SetPointe2Longueur };
        __property int Pointe2Largeur  = { read=FPointe2Largeur, write=SetPointe2Largeur };
	__property TColor Pointe2Couleur  = { read=FPointe2Couleur, write=SetPointe2Couleur };
        __property TFFormePointe Pointe2Forme  = { read=FPointe2Forme, write=SetPointe2Forme };
        __property int Pointe2Epaisseur  = { read=FPointe2Epaisseur, write=SetPointe2Epaisseur };
        //--------Pointe Gnrale
        __property TFPositionPointe PositionPointe  = { read=FPositionPointe, write=SetPositionPointe };



};
//---------------------------------------------------------------------------
#endif
